"use strict";

var _cssModulesFlowTypesPrinter = require("css-modules-flow-types-printer");

var _converter = _interopRequireDefault(require("../converter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-env jest */
var converter = new _converter.default('./fixtures', _cssModulesFlowTypesPrinter.EOL.LF);
it('returns sorted content from simple css', function () {
  return converter.convert('./example.css').then(function (content) {
    expect(content).toBe(`${_cssModulesFlowTypesPrinter.HEADER}
declare module.exports: {|
  +'a': string,
  +'my-class': string,
  +'myClass': string,
  +'primary': string,
  +'while': string,
|};
`);
  });
});
it('returns content from empty css files', function () {
  return converter.convert('./empty.css').then(function (content) {
    expect(content).toBe(`${_cssModulesFlowTypesPrinter.HEADER}
declare module.exports: {|

|};
`);
  });
});
it('rejects invalid CSS', function () {
  expect.assertions(1);
  return converter.convert('./errorCss.css').catch(function (err) {
    expect(err.name).toBe('CssSyntaxError');
  });
});
it('returns content from composing css', function () {
  return converter.convert('./composer.css').then(function (content) {
    expect(content).toBe(`${_cssModulesFlowTypesPrinter.HEADER}
declare module.exports: {|
  +'root': string,
|};
`);
  });
});
it('returns content from composing css whose has invalid import/composes', function () {
  return converter.convert('./invalidComposer.scss').then(function (content) {
    expect(content).toBe(`${_cssModulesFlowTypesPrinter.HEADER}
declare module.exports: {|
  +'myClass': string,
|};
`);
  });
});