"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _cssModulesLoaderCore = _interopRequireDefault(require("css-modules-loader-core"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var FileSystemLoader = /*#__PURE__*/function () {
  function FileSystemLoader(root, plugins) {
    _classCallCheck(this, FileSystemLoader);

    this.root = root;
    this.sources = {};
    this.importNr = 0;
    this.core = new _cssModulesLoaderCore.default(plugins);
    this.tokensByFile = {};
  }

  _createClass(FileSystemLoader, [{
    key: "fetch",
    value: function fetch(_newPath, relativeTo, _trace, initialContents) {
      var _this = this;

      var newPath = _newPath.replace(/^["']|["']$/g, ''),
          trace = _trace || String.fromCharCode(this.importNr++);

      return new Promise(function (resolve, reject) {
        var relativeDir = _path.default.dirname(relativeTo),
            rootRelativePath = _path.default.resolve(relativeDir, newPath),
            fileRelativePath = _path.default.resolve(_path.default.join(_this.root, relativeDir), newPath); // if the path is not relative or absolute, try to resolve it in node_modules


        if (newPath[0] !== '.' && newPath[0] !== '/') {
          try {
            fileRelativePath = require.resolve(newPath);
          } catch (e) {}
        }

        if (!initialContents) {
          var tokens = _this.tokensByFile[fileRelativePath];

          if (tokens) {
            return resolve(tokens);
          }

          _fs.default.readFile(fileRelativePath, 'utf-8', function (err, source) {
            if (err && relativeTo && relativeTo !== '/') {
              resolve([]);
            } else if (err && (!relativeTo || relativeTo === '/')) {
              reject(err);
            } else {
              _this.core.load(source, rootRelativePath, trace, _this.fetch.bind(_this)).then(function (_ref) {
                var injectableSource = _ref.injectableSource,
                    exportTokens = _ref.exportTokens;
                _this.sources[trace] = injectableSource;
                _this.tokensByFile[fileRelativePath] = exportTokens;
                resolve(exportTokens);
              }, reject);
            }
          });
        } else {
          _this.core.load(initialContents, rootRelativePath, trace, _this.fetch.bind(_this)).then(function (_ref2) {
            var injectableSource = _ref2.injectableSource,
                exportTokens = _ref2.exportTokens;
            _this.sources[trace] = injectableSource;
            _this.tokensByFile[fileRelativePath] = exportTokens;
            resolve(exportTokens);
          }, reject);
        }
      });
    }
  }]);

  return FileSystemLoader;
}();

exports.default = FileSystemLoader;